#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<string> split(string &s, char c) {
    vector<string> ans;
    string cur;
    for (char i : s) {
        if (i == c) {
            if (!cur.empty()) {
                ans.push_back(cur);
                cur = "";
            }
        } else {
            cur.push_back(i);
        }
    }
    if (!cur.empty()) {
        ans.push_back(cur);
        cur = "";
    }
    return ans;
}

long long count_mult(string s, long long mod) {
    long long ans = 1;
    auto v = split(s, '*');
    for (auto &p : v) {
        long long val = 0;
        for (char c : p) {
            val *= 10;
            val += c - '0';
            val %= mod;
        }
        ans *= val;
        ans %= mod;
    }
    return ans;
}

long long count(string s, long long mod) {
    long long ans = 0;
    auto v = split(s, '+');
    for (auto &p : v) {
        ans += count_mult(p, mod);
        ans %= mod;
    }
    return ans;
}

bool check(string s, int k, long long mod) {
    auto v = split(s, '=');
    if (v.size() != k + 1) {
        return false;
    }
    vector<long long> vals(k + 1);
    for (int i = 0; i < k + 1; i++) {
        vals[i] = count(v[i], mod);
    }
    for (int i = 1; i < k + 1; i++) {
        if (vals[i] != vals[0]) {
            return false;
        }
    }
    return true;
}

string oks;

string gen(string &s, int ind, string &cur, int k, long long mod) {
    if (ind == s.size()) {
        if (check(cur, k, mod)) {
            return cur;
        } else {
            return "";
        }
    }

    cur.push_back(s[ind]);
    auto ans1 = gen(s, ind + 1, cur, k, mod);
    if (!ans1.empty()) {
        return ans1;
    }
    cur.pop_back();

    if (ind != 0) {
        for (char c : oks) {
            if (c == 0) continue;

            cur.push_back(c);
            cur.push_back(s[ind]);

            auto ans = gen(s, ind + 1, cur, k, mod);
            if (!ans.empty()) {
                return ans;
            }

            cur.pop_back();
            cur.pop_back();
        }
    }

    return "";
}

string solve(string s, int k, long long mod) {
    string cur;
    string res = gen(s, 0, cur, k, mod);
    if (res.empty()) {
        return "Fail";
    } else {
        return res;
    }
}

int main() {
    int tt;
    cin >> tt;
    while (tt--) {
        int n, k;
        long long mod;
        int type;
        cin >> n >> k >> mod >> type;

        if (type == 1) {
            oks = "=+";
        } else if (type == 2) {
            oks = "=+*";
        }

        string s;
        cin >> s;

        cout << solve(s, k, mod) << endl;
    }

    return 0;
}