#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using namespace std;

const int MAXM = 500;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int mt;
    cin >> mt;
    while (mt--) {
        int n, k, m, t;
        cin >> n >> k >> m >> t;
        string s;
        cin >> s;

        bitset<MAXM> ones;
        for (int i = 0; i < m; i++) {
            ones[i] = true;
        }

        vector<vector<long long>> val(n, vector<long long>(n));
        for (int i = 0; i < n; i++) {
            val[i][i] = (s[i] - '0') % m;
            for (int j = i + 1; j < n; j++) {
                val[i][j] = (val[i][j - 1] * 10 + (s[j] - '0')) % m;
            }
        }

        vector<vector<bitset<MAXM>>> dpm(n, vector<bitset<MAXM>>(n));
        vector<vector<vector<int>>> prvm(n, vector<vector<int>>(n, vector<int>(m)));
        vector<vector<vector<int>>> prvval(n, vector<vector<int>>(n, vector<int>(m)));
        for (int l = 1; l <= n; l++) {
            for (int i = 0; i + l <= n; i++) {
                int j = i + l - 1;
                dpm[i][j][val[i][j]] = true;
                prvm[i][j][val[i][j]] = -1;
                if (t == 2) {
                    for (int j1 = i; j1 < j; j1++) {
                        for (int m1 = 0; m1 < m; m1++) {
                            if (dpm[i][j1][m1]) {
                                dpm[i][j][(1LL * m1 * val[j1 + 1][j]) % m] = true;
                                prvm[i][j][(1LL * m1 * val[j1 + 1][j]) % m] = j1;
                                prvval[i][j][(1LL * m1 * val[j1 + 1][j]) % m] = m1;
                            }
                        }
                    }
                }
            }
        }

        vector<vector<bitset<MAXM>>> dp(n, vector<bitset<MAXM>>(n));

        for (int l = 1; l <= n; l++) {
            for (int i = 0; i + l <= n; i++) {
                int j = i + l - 1;
                for (int m0 = 0; m0 < m; m0++) {
                    if (dpm[i][j][m0]) {
                        dp[i][j][m0] = true;
                    }
                }
                for (int j1 = i; j1 < j; j1++) {
                    for (int m1 = 0; m1 < m; m1++) {
                        if (dp[i][j1][m1]) {
                            // dp[i][j] |= (dpm[j + 1][j][m2] shifted right by m1)
                            dp[i][j] |= (dpm[j1 + 1][j] << m1) & ones;
                            dp[i][j] |= dpm[j1 + 1][j] >> (m - m1);
                        }
//                        for (int m2 = 0; m2 < m; m2++) {
//                            if (dp[i][j1][m1] && dpm[j1 + 1][j][m2]) {
//                                dp[i][j][(m1 + m2) % m] = true;
//                            }
//                        }
                    }
                }
            }
        }

        k++;
        bool ok = false;
        for (int ans = 0; ans < m; ans++) {
            vector<vector<bool>> dp1(n + 1, vector<bool>(k + 1));
            vector<vector<int>> prev1(n + 1, vector<int>(k + 1));
            prev1[0][0] = -1;
            dp1[0][0] = true;
            for (int i = 0; i < n; i++) {
                for (int c = 0; c < k; c++) {
                    if (dp1[i][c]) {
                        for (int j = i; j < n; j++) {
                            if (dp[i][j][ans]) {
                                dp1[j + 1][c + 1] = true;
                                prev1[j + 1][c + 1] = i;
                            }
                        }
                    }
                }
            }

            if (dp1[n][k]) {
                vector<int> begs;
                int cur = n;
                int cc = k;
                while (cur != -1) {
                    begs.push_back(cur);
                    cur = prev1[cur][cc];
                    cc--;
                }
                reverse(begs.begin(), begs.end());

                vector<bool> eq(n);
                for (int i = 1; i < begs.size() - 1; i++) {
                    eq[begs[i] - 1] = true;
                }

                vector<bool> plus(n);
                vector<bool> mlt(n);

                vector<int> mbl, mbr, mbv;

                for (int i = 0; i < k; i++) {
                    int l = begs[i];
                    int r = begs[i + 1] - 1;
                    int vl = ans;

                    for (int r1 = r - 1; r1 >= l; r1--) {
                        int v1 = -1;
                        for (int pv1 = 0; pv1 < m; pv1++) {
                            if (dp[l][r1][pv1] && dpm[r1 + 1][r][(vl - pv1 + m) % m]) {
                                v1 = pv1;
                            }
                        }

                        if (v1 != -1) {
                            mbl.push_back(r1 + 1);
                            mbr.push_back(r);
                            mbv.push_back((vl - v1 + m) % m);
                            vl = v1;
                            plus[r1] = true;
                            r = r1;
                        }
                    }

                    mbl.push_back(l);
                    mbr.push_back(r);
                    mbv.push_back(vl);
                }

                for (int i = 0; i < mbl.size(); i++) {
                    int l = mbl[i], r = mbr[i], v = mbv[i];
                    while (r != -1) {
                        int r1 = prvm[l][r][v];
                        int v1 = prvval[l][r][v];

                        if (r1 != -1) {
                            mlt[r1] = true;
                        }

                        r = r1;
                        v = v1;
                    }
                }

                for (int i = 0; i < n; i++) {
                    cout << s[i];
                    if (eq[i]) {
                        cout << "=";
                    }
                    if (plus[i]) {
                        cout << "+";
                    }
                    if (mlt[i]) {
                        cout << "*";
                    }
                }
                cout << "\n";

                ok = true;
                break;
            }
        }

        if (!ok) {
            cout << "Fail\n";
        }
    }

    return 0;
}
