#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using namespace std;

void solve_m3md32(int n, int k, int m, int t, string &s) {
    const int MAXM = 1000;

    bitset<MAXM> ones;
    for (int i = 0; i < m; i++) {
        ones[i] = true;
    }

    vector<vector<int>> val(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        val[i][i] = (s[i] - '0') % m;
        for (int j = i + 1; j < n; j++) {
            val[i][j] = (val[i][j - 1] * 10 + (s[j] - '0')) % m;
        }
    }

    vector<vector<bitset<MAXM>>> dp(n, vector<bitset<MAXM>>(n));
    for (int l = 1; l <= n; l++) {
        for (int i = 0; i + l <= n; i++) {
            int j = i + l - 1;
            dp[i][j][val[i][j]] = true;
            for (int j1 = i; j1 < j; j1++) {
                int v = val[j1 + 1][j];

                dp[i][j] |= (dp[i][j1] << v) & ones;
                dp[i][j] |= (dp[i][j1] >> (m - v));
            }
        }
    }

    k++;
    bool ok = false;
    for (int ans = 0; ans < m; ans++) {
        vector<vector<bool>> dp1(n + 1, vector<bool>(k + 1));
        vector<vector<int>> prev1(n + 1, vector<int>(k + 1));
        prev1[0][0] = -1;
        dp1[0][0] = true;
        for (int i = 0; i < n; i++) {
            for (int c = 0; c < k; c++) {
                if (dp1[i][c]) {
                    for (int j = i; j < n; j++) {
                        if (dp[i][j][ans]) {
                            dp1[j + 1][c + 1] = true;
                            prev1[j + 1][c + 1] = i;
                        }
                    }
                }
            }
        }

        if (dp1[n][k]) {
            vector<int> begs;
            int cur = n;
            int cc = k;
            while (cur != -1) {
                begs.push_back(cur);
                cur = prev1[cur][cc];
                cc--;
            }
            reverse(begs.begin(), begs.end());

            vector<bool> eq(n);
            for (int i = 1; i < begs.size() - 1; i++) {
                eq[begs[i] - 1] = true;
            }

            vector<bool> plus(n);

            for (int i = 0; i < k; i++) {
                int l = begs[i];
                int r = begs[i + 1] - 1;
                int vl = ans;

                for (int r1 = r - 1; r1 >= l; r1--) {
                    int vl1 = (vl - val[r1 + 1][r] + m) % m;
                    if (dp[l][r1][vl1]) {
                        plus[r1] = true;
                        r = r1;
                        vl = vl1;
                    }
                }
            }

            for (int i = 0; i < n; i++) {
                cout << s[i];
                if (eq[i]) {
                    cout << "=";
                }
                if (plus[i]) {
                    cout << "+";
                }
            }
            cout << "\n";

            ok = true;
            break;
        }
    }

    if (!ok) {
        cout << "Fail\n";
    }
}

vector<string> bf_split(string &s, char c) {
    vector<string> ans;
    string cur;
    for (char i : s) {
        if (i == c) {
            if (!cur.empty()) {
                ans.push_back(cur);
                cur = "";
            }
        } else {
            cur.push_back(i);
        }
    }
    if (!cur.empty()) {
        ans.push_back(cur);
        cur = "";
    }
    return ans;
}

long long bf_count_mult(string s, long long mod) {
    long long ans = 1;
    auto v = bf_split(s, '*');
    for (auto &p : v) {
        long long val = 0;
        for (char c : p) {
            val *= 10;
            val += c - '0';
            val %= mod;
        }
        ans *= val;
        ans %= mod;
    }
    return ans;
}

long long bf_count(string s, long long mod) {
    long long ans = 0;
    auto v = bf_split(s, '+');
    for (auto &p : v) {
        ans += bf_count_mult(p, mod);
        ans %= mod;
    }
    return ans;
}

bool bf_check(string s, int k, long long mod) {
    auto v = bf_split(s, '=');
    if (v.size() != k + 1) {
        return false;
    }
    vector<long long> vals(k + 1);
    for (int i = 0; i < k + 1; i++) {
        vals[i] = bf_count(v[i], mod);
    }
    for (int i = 1; i < k + 1; i++) {
        if (vals[i] != vals[0]) {
            return false;
        }
    }
    return true;
}

string oks;

string bf_gen(string &s, int ind, string &cur, int k, long long mod) {
    if (ind == s.size()) {
        if (bf_check(cur, k, mod)) {
            return cur;
        } else {
            return "";
        }
    }

    cur.push_back(s[ind]);
    auto ans1 = bf_gen(s, ind + 1, cur, k, mod);
    if (!ans1.empty()) {
        return ans1;
    }
    cur.pop_back();

    if (ind != 0) {
        for (char c : oks) {
            if (c == 0) continue;

            cur.push_back(c);
            cur.push_back(s[ind]);

            auto ans = bf_gen(s, ind + 1, cur, k, mod);
            if (!ans.empty()) {
                return ans;
            }

            cur.pop_back();
            cur.pop_back();
        }
    }

    return "";
}

string bf_solve(string s, int k, long long mod) {
    string cur;
    string res = bf_gen(s, 0, cur, k, mod);
    if (res.empty()) {
        return "Fail";
    } else {
        return res;
    }
}

void solve_bruteforce(int n, int k, int m, int t, string &s) {
    if (t == 1) {
        oks = "=+";
    } else if (t == 2) {
        oks = "=*+";
    }
    cout << bf_solve(s, k, m) << "\n";
}

void solve_n3m2d32(int n, int k, int m, int t, string &s) {
    const int MAXM = 500;
    bitset<MAXM> ones;
    for (int i = 0; i < m; i++) {
        ones[i] = true;
    }

    vector<vector<long long>> val(n, vector<long long>(n));
    for (int i = 0; i < n; i++) {
        val[i][i] = (s[i] - '0') % m;
        for (int j = i + 1; j < n; j++) {
            val[i][j] = (val[i][j - 1] * 10 + (s[j] - '0')) % m;
        }
    }

    vector<vector<bitset<MAXM>>> dpm(n, vector<bitset<MAXM>>(n));
    vector<vector<vector<int>>> prvm(n, vector<vector<int>>(n, vector<int>(m)));
    vector<vector<vector<int>>> prvval(n, vector<vector<int>>(n, vector<int>(m)));
    for (int l = 1; l <= n; l++) {
        for (int i = 0; i + l <= n; i++) {
            int j = i + l - 1;
            dpm[i][j][val[i][j]] = true;
            prvm[i][j][val[i][j]] = -1;
            if (t == 2) {
                for (int j1 = i; j1 < j; j1++) {
                    for (int m1 = 0; m1 < m; m1++) {
                        if (dpm[i][j1][m1]) {
                            dpm[i][j][(1LL * m1 * val[j1 + 1][j]) % m] = true;
                            prvm[i][j][(1LL * m1 * val[j1 + 1][j]) % m] = j1;
                            prvval[i][j][(1LL * m1 * val[j1 + 1][j]) % m] = m1;
                        }
                    }
                }
            }
        }
    }

    vector<vector<bitset<MAXM>>> dp(n, vector<bitset<MAXM>>(n));

    for (int l = 1; l <= n; l++) {
        for (int i = 0; i + l <= n; i++) {
            int j = i + l - 1;
            for (int m0 = 0; m0 < m; m0++) {
                if (dpm[i][j][m0]) {
                    dp[i][j][m0] = true;
                }
            }
            for (int j1 = i; j1 < j; j1++) {
                for (int m1 = 0; m1 < m; m1++) {
                    if (dp[i][j1][m1]) {
                        dp[i][j] |= (dpm[j1 + 1][j] << m1) & ones;
                        dp[i][j] |= dpm[j1 + 1][j] >> (m - m1);
                    }
                }
            }
        }
    }

    k++;
    bool ok = false;
    for (int ans = 0; ans < m; ans++) {
        vector<vector<bool>> dp1(n + 1, vector<bool>(k + 1));
        vector<vector<int>> prev1(n + 1, vector<int>(k + 1));
        prev1[0][0] = -1;
        dp1[0][0] = true;
        for (int i = 0; i < n; i++) {
            for (int c = 0; c < k; c++) {
                if (dp1[i][c]) {
                    for (int j = i; j < n; j++) {
                        if (dp[i][j][ans]) {
                            dp1[j + 1][c + 1] = true;
                            prev1[j + 1][c + 1] = i;
                        }
                    }
                }
            }
        }

        if (dp1[n][k]) {
            vector<int> begs;
            int cur = n;
            int cc = k;
            while (cur != -1) {
                begs.push_back(cur);
                cur = prev1[cur][cc];
                cc--;
            }
            reverse(begs.begin(), begs.end());

            vector<bool> eq(n);
            for (int i = 1; i < begs.size() - 1; i++) {
                eq[begs[i] - 1] = true;
            }

            vector<bool> plus(n);
            vector<bool> mlt(n);

            vector<int> mbl, mbr, mbv;

            for (int i = 0; i < k; i++) {
                int l = begs[i];
                int r = begs[i + 1] - 1;
                int vl = ans;

                for (int r1 = r - 1; r1 >= l; r1--) {
                    int v1 = -1;
                    for (int pv1 = 0; pv1 < m; pv1++) {
                        if (dp[l][r1][pv1] && dpm[r1 + 1][r][(vl - pv1 + m) % m]) {
                            v1 = pv1;
                        }
                    }

                    if (v1 != -1) {
                        mbl.push_back(r1 + 1);
                        mbr.push_back(r);
                        mbv.push_back((vl - v1 + m) % m);
                        vl = v1;
                        plus[r1] = true;
                        r = r1;
                    }
                }

                mbl.push_back(l);
                mbr.push_back(r);
                mbv.push_back(vl);
            }

            for (int i = 0; i < mbl.size(); i++) {
                int l = mbl[i], r = mbr[i], v = mbv[i];
                while (r != -1) {
                    int r1 = prvm[l][r][v];
                    int v1 = prvval[l][r][v];

                    if (r1 != -1) {
                        mlt[r1] = true;
                    }

                    r = r1;
                    v = v1;
                }
            }

            for (int i = 0; i < n; i++) {
                cout << s[i];
                if (eq[i]) {
                    cout << "=";
                }
                if (plus[i]) {
                    cout << "+";
                }
                if (mlt[i]) {
                    cout << "*";
                }
            }
            cout << "\n";

            ok = true;
            break;
        }
    }

    if (!ok) {
        cout << "Fail\n";
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int mt;
    cin >> mt;
    vector<int> ns(mt), ks(mt), ms(mt), ts(mt);
    vector<string> ss(mt);
    int N = 0;
    for (int i = 0; i < mt; i++) {
        cin >> ns[i] >> ks[i] >> ms[i] >> ts[i];
        N += ns[i];
        cin >> ss[i];
    }

    for (int i = 0; i < mt; i++) {
        if (N <= 10 || ns[i] == 4) {
            solve_bruteforce(ns[i], ks[i], ms[i], ts[i], ss[i]);
        } else if (ts[i] == 2) {
            solve_n3m2d32(ns[i], ks[i], ms[i], ts[i], ss[i]);
        } else {
            solve_m3md32(ns[i], ks[i], ms[i], ts[i], ss[i]);
        }
    }

    return 0;
}
